      subroutine plqcd3j(imode,isel)
      implicit none

      INCLUDE 'inclk.h'
      INCLUDE 'grchad.inc'

      INTEGER MXDIM,NDMX,NDIM,NWILD,IG,NCALL,ITMX1,ITMX2
      DOUBLE PRECISION XL,XU,ACC1,ACC2
      PARAMETER (MXDIM = 50, NDMX = 50 )
      COMMON /BPARM1/ XL(MXDIM),XU(MXDIM),NDIM,NWILD,
     $     IG(MXDIM),NCALL
      COMMON /BPARM2/ ACC1,ACC2,ITMX1,ITMX2

      INTEGER JPROC
      COMMON /AMJPRC/JPROC

      CHARACTER GRCPROC*40
      COMMON/GRCCHAR/GRCPROC

      INTEGER i,imode,isel
      real*8  xsn(10),rna
      integer imrg,ijrg


C...Decide subprocess ID.
      if (imode.eq.1) then
         ijrg = 308
         imrg = 9
         xsn(2) = 0.20d0
         xsn(3) = 0.30d0
         xsn(4) = 0.40d0
         xsn(5) = 0.50d0
         xsn(6) = 0.60d0
         xsn(7) = 0.70d0
         xsn(8) = 0.80d0
         xsn(9) = 0.90d0
C...Inclusive heavy flavor production.
         if (igjflv(7).eq.0) then
            imrg = 7
            xsn(2) = 0.20d0     ! 312
            xsn(3) = 0.40d0     ! 313
            xsn(4) = 0.60d0     ! 314
            xsn(5) = 0.70d0     ! 315
            xsn(6) = 0.80d0     ! 316
            xsn(7) = 0.90d0     ! 317
         endif
C...top quark production.
         if (igjflv(1)+igjflv(2)+igjflv(3)+igjflv(4)
     $        +igjflv(5)+igjflv(7).eq.0.and.igjflv(6).eq.1) then
            imrg = 3
            xsn(2) = 0.40d0     ! 312
            xsn(3) = 0.80d0     ! 314
         endif
         rna = xrun(8)
         xsn(1) = 0.0d0
         xsn(imrg+1) = 1.0d0
         do i = 1,imrg
            if (rna.gt.xsn(i).and.rna.le.xsn(i+1)) then
               gpri(10) = (rna-xsn(i))/(xsn(i+1)-xsn(i))
               yacob = yacob/(xsn(i+1)-xsn(i))
               jproc = i + ijrg
            endif
         enddo

C...top quark production.
         if (igjflv(1)+igjflv(2)+igjflv(3)+igjflv(4)
     $        +igjflv(5)+igjflv(7).eq.0.and.igjflv(6).eq.1) then
            if (jproc.eq.311) jproc = 314
            if (jproc.eq.310) jproc = 312
            if (jproc.eq.309) jproc = 310
C...Inclusive heavy flavor production.
         else if (igjflv(7).eq.0) then
            if (jproc.eq.315) jproc = 317
            if (jproc.eq.314) jproc = 316
            if (jproc.eq.313) jproc = 315
            if (jproc.eq.312) jproc = 314
            if (jproc.eq.311) jproc = 313
            if (jproc.eq.310) jproc = 312
            if (jproc.eq.309) jproc = 310
         endif

C...Set dimension and process character.
      else if (imode.eq.2) then
	 ndim = 9
         if (isel.eq.183) grcproc = 'pp(bar) -> 3 jets (QCD3)'
         if (isel.eq.309) grcproc = 'gg -> ggg (QCD3)'
         if (isel.eq.310) grcproc = 'qq -> qqg (QCD3)'
         if (isel.eq.311) grcproc = 'qq -> ggg (QCD3)'
         if (isel.eq.312) grcproc = 'gg -> qqg (QCD3)'
         if (isel.eq.313) grcproc = 'qg -> qgg (QCD3)'
         if (isel.eq.314) grcproc = 'qg -> qqq (QCD3)'
         if (isel.eq.315) grcproc = 'qq -> qqg (QCD3)'
         if (isel.eq.316) grcproc = 'qq -> qqg (QCD3)'
         if (isel.eq.317) grcproc = 'qq -> qqg (QCD3)'

C...Initialize kinematic parameter.
      else if (imode.eq.3) then
	 mxreg = 1
	 ktype = 2301
	 cxtype = 12534
	 gtau(1) = 1
	 gtau(14) = 2
	 gyst(1) = 1
	 gyst(14) = 5
	 gcos3(1) = 1
	 gcos3(14) = 4
	 gq12(1) = 1
	 gq12(2) = 2.0d0**2
	 gq12(14) = 2

C...Set flavor and if necessary, decide weight of each phase space.
      else if (imode.eq.4) then
         isel = 1
      endif

      return
      end
